# querystring

Блок `querystring` служит для работы с адресной строкой браузера – обработки и формирования запросов.

Блок реализован в технологии `vanila.js` и подходит для использования как на клиенте, так и на сервере.

## Публичные методы блока

### `parse` 

Метод служит для формирования объекта на основании параметров запроса адресной строки. 

Метод принимает на вход строку с параметрами и возвращает сформированный объект. Параметры передаются в виде пар ключ-значение с символом `=` в качестве разделителя. Пары отделяются символом `&`. В ходе работы метода, ключи и значения декодируются из формата URI;

### `stringify`

Метод служит для формирования строки запроса с набором параметров на основании собственных свойств объекта. 

На вход метод принимает объект и возвращает сформированную строку запроса. В строке имена свойств отделяются от значений символом `=`, пары разделяются символом `&`. 

## Элементы блока

### __uri

Элемент предназначен для декодирования строки из формата URI. 

Элемент предоставляет следующий набор публичных методов:

* `decodeURI` – декодирование URI. Заменяет каждую последовательность экранирования в строке URI соответствующим символом. Метод поддерживает тот же набор последовательностей, что и стандартный метод JavaScript `encodeURI`. Символ `#` не декодируется.
* `decodeURIComponent` – декодирование компонента URI. Заменяет каждую последовательность экранирования в строке URI соответствующим символом. Метод позволяет декодировать компонент URI, сформированный методом `encodeURIComponent`. Декодируются последовательности, соответствующие символам `&`, `+`, и `=`.

Оба метода являются оберткой над соответствующими стандартными методами JavaScript `decodeURI` и `decodeURIComponent`. 

В ходе работы методов производится проверка входной строки на:

* соответствие формата переданной строки UTF-8. При несоответствии генерируется ошибка.
* наличие последовательностей экранирования. Если последовательности не найдены методы возвращают строку без изменений.
